<template>
  <div>
    <!--<template>
      <hsc-window-style-white>
        <hsc-window
          style=" z-index:2000"
          :resizable="true"
          :isScrollable="true"
          :minHeight="300"
          :maxHeight="500"
          :minWidth="300"
          :maxWidth="400"
          title="Viewer Objects"
          :width="400"
          :height="300"
        >
          <json-view :data="$data" />
        </hsc-window>
      </hsc-window-style-white>
    </template>-->
    <v-tabs
      class="custom-tab"
      height="46"
      color="white"
      active-class="active-tab"
      grow
      background-color="#f2f2f2"
      show-arrows
    >
      <v-tabs-slider color="primary"></v-tabs-slider>
      <v-tab
        :class="[
          {
            'tab-validation-error':
              $v.modeloVuelidate.ejes_modelo.$each[indexEjeModelo].$error
          }
        ]"
        v-for="(ejeModelo, indexEjeModelo) in ejesActiveModelo()"
        :key="indexEjeModelo"
      >
        <div>
          {{
            serviceCommons.titleCase(
              getEjeFromMetadata(ejeModelo.id_eje).descripcion
            )
          }}
        </div>
        <template
          v-if="$v.modeloVuelidate.ejes_modelo.$each[indexEjeModelo].$error"
        >
          <v-popover placement="bottom-end" offset="16">
            <v-icon class color="white">mdi-alert-circle</v-icon>
            <template slot="popover">
              <span
                @click="
                  $v.modeloVuelidate.ejes_modelo.$each[indexEjeModelo].$reset()
                "
                v-close-popover
              >
                <span
                  v-if="
                    $v.modeloVuelidate.ejes_modelo.$each[indexEjeModelo].$error
                  "
                  >¡Tienes errores en este eje!</span
                >
              </span>
            </template>
          </v-popover>
        </template>
      </v-tab>
      <v-tab-item
        class="pt-4"
        v-for="(ejeModelo, indexEjeModelo) in ejesActiveModelo()"
        :key="indexEjeModelo"
      >
        <!--   <v-text-field
          v-model.trim="ejeModelo.search_disciplina"
          class="float-right pt-0 mt-0"
          clearable
          label="Buscar..."
          type="text"
        >
          <template v-slot:append>
            <v-tooltip bottom>
              <template v-slot:activator="{ on }">
                <v-icon v-on="on">mdi-card-search-outline</v-icon>
              </template>
              Buscar
            </v-tooltip>
          </template>
        </v-text-field>-->
        <div class="titSec">Disciplinas</div>
        <div class="gris">
          <template v-if="!tempEditingDisciplina">
            <v-sheet
              class="overflow-y-auto CardScrollDisciplina"
              style="background : none;"
            >
              <v-row>
                <v-col
                  class="pa-0"
                  :cols="12"
                  offset-xs="9"
                  offset-sm="9"
                  offset-md="9"
                  offset-lg="10"
                  offset-xl="11"
                  :xs="3"
                  :sm="3"
                  :md="3"
                  :lg="2"
                  :xl="1"
                >
                  <div class="titSec mr-4 pa-0">
                    {{ disciplinasActiveEje(indexEjeModelo).length }}
                    Disciplinas
                  </div>
                </v-col>
              </v-row>
              <template
                v-for="(disciplinaEje,
                indexDisciplinaEje) in disciplinasActiveEje(indexEjeModelo)"
              >
                <v-card
                  :key="indexDisciplinaEje"
                  class="mt-2"
                  color="transparent"
                >
                  <v-btn
                    @click="
                      tempIndexEjeModeloDeleting = indexEjeModelo;
                      tempIndexDeletingDisciplinaEje = indexDisciplinaEje;
                      tempDeletingDisciplinaEje = disciplinaEje;
                      dialogDelete = true;
                    "
                    small
                    class="float-right mt-9 mr-5"
                    text
                    icon
                  >
                    <v-img
                      :contain="true"
                      :aspect-ratio="1"
                      position="center"
                      src="@/assets/img/delete.svg"
                      class="white--text align-end"
                    ></v-img>
                  </v-btn>
                  <v-row style="max-height: 400px; overflow: auto;">
                    <v-col cols="12" md="1">
                      No.
                      <v-text-field
                        class="mt-0 pt-1"
                        placeholder="No."
                        maxlength="2"
                        disabled
                        style="width:25px;"
                        flat
                        :value="disciplinaEje.no"
                        background-color="white"
                      ></v-text-field>
                    </v-col>
                    <v-col :cols="12" :xs="12" :sm="12" :md="3" :lg="3" :xl="2">
                      Nombre de la disciplina
                      <span class="tRojo">*</span>
                      <v-autocomplete
                        class="mt-0 pt-1"
                        placeholder="Nombre de la disciplina"
                        v-model="disciplinaEje.id_disciplina"
                        :hide-no-data="!disciplinaEje.search_disciplina"
                        :items="avalibleDisciplina"
                        item-disabled="disabled"
                        item-text="descripcion"
                        item-value="id_disciplina"
                        :search-input.sync="disciplinaEje.search_disciplina"
                        background-color="white"
                        persistent-hint
                        small-chips
                        clearable
                        :error="
                          $v.modeloVuelidate.ejes_modelo.$each[indexEjeModelo]
                            .disciplinas_eje.$each[indexDisciplinaEje]
                            .id_disciplina.$error
                        "
                      >
                        <template v-slot:no-data>
                          <v-list-item>
                            <v-list-item-content>
                              <v-list-item-title>
                                No se encontraron resultados "
                                <strong>
                                  {{ disciplinaEje.search_disciplina }} </strong
                                >".
                                <v-btn
                                  x-small
                                  class="black--text"
                                  dark
                                  tile
                                  color="primary"
                                  @click="
                                    editTempDisciplina({
                                      descripcion:
                                        disciplinaEje.search_disciplina
                                    })
                                  "
                                >
                                  <v-avatar size="15" tile>
                                    <v-img
                                      :contain="true"
                                      :aspect-ratio="1"
                                      position="center"
                                      src="@/assets/img/icoSimpleAgregar.svg"
                                      class="black--text"
                                    ></v-img> </v-avatar
                                  >Agregar
                                </v-btn>
                              </v-list-item-title>
                            </v-list-item-content>
                          </v-list-item>
                        </template>
                        <template
                          v-slot:selection="{ attrs, item, parent, selected }"
                        >
                          <v-chip
                            v-if="item === Object(item)"
                            v-bind="attrs"
                            :input-value="selected"
                            :color="!selected ? 'primary' : ''"
                            label
                            small
                          >
                            <span class="pr-2">{{ item.descripcion }}</span>
                          </v-chip>
                        </template>
                        <template v-slot:item="{ index, item }">
                          <v-chip dark label small>
                            {{ item.descripcion }}
                          </v-chip>
                          <v-spacer></v-spacer>
                          <v-list-item-action @click.stop>
                            <v-btn
                              icon
                              @keyup.stop.prevent="editTempDisciplina(item)"
                              @click.stop.prevent="editTempDisciplina(item)"
                            >
                              <v-icon>mdi-pencil</v-icon>
                            </v-btn>
                          </v-list-item-action>
                        </template>
                        <template
                          v-if="
                            $v.modeloVuelidate.ejes_modelo.$each[indexEjeModelo]
                              .disciplinas_eje.$each[indexDisciplinaEje]
                              .id_disciplina.$error
                          "
                          v-slot:append-outer
                        >
                          <v-popover placement="bottom-end" offset="16">
                            <v-icon class color="#fd5151"
                              >mdi-alert-circle</v-icon
                            >
                            <template slot="popover">
                              <span
                                @click="
                                  $v.modeloVuelidate.ejes_modelo.$each[
                                    indexEjeModelo
                                  ].disciplinas_eje.$each[
                                    indexDisciplinaEje
                                  ].id_disciplina.$reset()
                                "
                                v-close-popover
                              >
                                <span
                                  v-if="
                                    !$v.modeloVuelidate.ejes_modelo.$each[
                                      indexEjeModelo
                                    ].disciplinas_eje.$each[indexDisciplinaEje]
                                      .id_disciplina.required
                                  "
                                  >¡No te olvides de éste campo!</span
                                >
                              </span>
                            </template>
                          </v-popover>
                        </template>
                      </v-autocomplete>
                    </v-col>
                    <v-col>
                      Medición
                      <span class="tRojo">*</span>
                      <v-radio-group
                        v-model="disciplinaEje.id_tipo_medicion"
                        class="mt-0 pt-1"
                        :error="
                          $v.modeloVuelidate.ejes_modelo.$each[indexEjeModelo]
                            .disciplinas_eje.$each[indexDisciplinaEje]
                            .id_tipo_medicion.$error
                        "
                      >
                        <v-radio
                          v-for="(tipo_medicion,
                          indexTipoMedicion) in metadata.tipo_medicion"
                          :key="indexTipoMedicion"
                          :label="tipo_medicion.descripcion"
                          color="primary"
                          :value="tipo_medicion.id_tipo_medicion"
                        ></v-radio>
                        <template
                          v-if="
                            $v.modeloVuelidate.ejes_modelo.$each[indexEjeModelo]
                              .disciplinas_eje.$each[indexDisciplinaEje]
                              .id_tipo_medicion.$error
                          "
                          v-slot:append
                        >
                          <v-popover placement="bottom-end" offset="16">
                            <v-icon class color="#fd5151"
                              >mdi-alert-circle</v-icon
                            >
                            <template slot="popover">
                              <span
                                @click="
                                  $v.modeloVuelidate.ejes_modelo.$each[
                                    indexEjeModelo
                                  ].disciplinas_eje.$each[
                                    indexDisciplinaEje
                                  ].id_tipo_medicion.$reset()
                                "
                                v-close-popover
                              >
                                <span
                                  v-if="
                                    !$v.modeloVuelidate.ejes_modelo.$each[
                                      indexEjeModelo
                                    ].disciplinas_eje.$each[indexDisciplinaEje]
                                      .id_tipo_medicion.required
                                  "
                                  >¡No te olvides de éste campo!</span
                                >
                              </span>
                            </template>
                          </v-popover>
                        </template>
                      </v-radio-group>
                    </v-col>
                    <v-col>
                      Frecuencia de medición
                      <span class="tRojo">*</span>
                      <v-radio-group
                        v-model="disciplinaEje.id_frecuencia_medicion"
                        class="mt-0 pt-1"
                        :error="
                          $v.modeloVuelidate.ejes_modelo.$each[indexEjeModelo]
                            .disciplinas_eje.$each[indexDisciplinaEje]
                            .id_frecuencia_medicion.$error
                        "
                      >
                        <v-radio
                          v-for="(frecuencia_medicion,
                          indexFrecuenciaMedicion) in metadata.frecuencia_medicion"
                          :key="indexFrecuenciaMedicion"
                          :label="frecuencia_medicion.descripcion"
                          color="primary"
                          :value="frecuencia_medicion.id_frecuencia_medicion"
                        ></v-radio>
                        <template
                          v-if="
                            $v.modeloVuelidate.ejes_modelo.$each[indexEjeModelo]
                              .disciplinas_eje.$each[indexDisciplinaEje]
                              .id_frecuencia_medicion.$error
                          "
                          v-slot:append
                        >
                          <v-popover placement="bottom-end" offset="16">
                            <v-icon class color="#fd5151"
                              >mdi-alert-circle</v-icon
                            >
                            <template slot="popover">
                              <span
                                @click="
                                  $v.modeloVuelidate.ejes_modelo.$each[
                                    indexEjeModelo
                                  ].disciplinas_eje.$each[
                                    indexDisciplinaEje
                                  ].id_frecuencia_medicion.$reset()
                                "
                                v-close-popover
                              >
                                <span
                                  v-if="
                                    !$v.modeloVuelidate.ejes_modelo.$each[
                                      indexEjeModelo
                                    ].disciplinas_eje.$each[indexDisciplinaEje]
                                      .id_frecuencia_medicion.required
                                  "
                                  >¡No te olvides de éste campo!</span
                                >
                              </span>
                            </template>
                          </v-popover>
                        </template>
                      </v-radio-group>
                    </v-col>
                    <v-col>
                      ¿Quien lo ejecuta?
                      <span class="tRojo">*</span>
                      <v-radio-group
                        :error="
                          $v.modeloVuelidate.ejes_modelo.$each[indexEjeModelo]
                            .disciplinas_eje.$each[indexDisciplinaEje]
                            .id_ejecuta.$error
                        "
                        v-model="disciplinaEje.id_ejecuta"
                        class="mt-0 pt-1"
                      >
                        <v-radio
                          v-for="(ejecuta, indexEjecuta) in metadata.ejecuta"
                          :key="indexEjecuta"
                          :label="ejecuta.descripcion"
                          color="primary"
                          :value="ejecuta.id_ejecuta"
                        ></v-radio>
                        <template
                          v-if="
                            $v.modeloVuelidate.ejes_modelo.$each[indexEjeModelo]
                              .disciplinas_eje.$each[indexDisciplinaEje]
                              .id_ejecuta.$error
                          "
                          v-slot:append
                        >
                          <v-popover placement="bottom-end" offset="16">
                            <v-icon class color="#fd5151"
                              >mdi-alert-circle</v-icon
                            >
                            <template slot="popover">
                              <span
                                @click="
                                  $v.modeloVuelidate.ejes_modelo.$each[
                                    indexEjeModelo
                                  ].disciplinas_eje.$each[
                                    indexDisciplinaEje
                                  ].id_ejecuta.$reset()
                                "
                                v-close-popover
                              >
                                <span
                                  v-if="
                                    !$v.modeloVuelidate.ejes_modelo.$each[
                                      indexEjeModelo
                                    ].disciplinas_eje.$each[indexDisciplinaEje]
                                      .id_ejecuta.required
                                  "
                                  >¡No te olvides de éste campo!</span
                                >
                              </span>
                            </template>
                          </v-popover>
                        </template>
                      </v-radio-group>
                    </v-col>
                    <v-col>
                      Driver de la experiencia
                      <span class="tRojo">*</span>
                      <v-radio-group
                        v-model="disciplinaEje.driver_experiencia"
                        class="mt-0 pt-1"
                        :error="
                          $v.modeloVuelidate.ejes_modelo.$each[indexEjeModelo]
                            .disciplinas_eje.$each[indexDisciplinaEje]
                            .driver_experiencia.$error
                        "
                      >
                        <v-radio
                          v-for="(driver_experiencia,
                          indexDriverExperiencia) in metadata.driver_experiencia"
                          :key="indexDriverExperiencia"
                          :label="driver_experiencia.descripcion"
                          color="primary"
                          :value="driver_experiencia.value"
                        ></v-radio>
                        <template
                          v-if="
                            $v.modeloVuelidate.ejes_modelo.$each[indexEjeModelo]
                              .disciplinas_eje.$each[indexDisciplinaEje]
                              .driver_experiencia.$error
                          "
                          v-slot:append
                        >
                          <v-popover placement="bottom-end" offset="16">
                            <v-icon class color="#fd5151"
                              >mdi-alert-circle</v-icon
                            >
                            <template slot="popover">
                              <span
                                @click="
                                  $v.modeloVuelidate.ejes_modelo.$each[
                                    indexEjeModelo
                                  ].disciplinas_eje.$each[
                                    indexDisciplinaEje
                                  ].driver_experiencia.$reset()
                                "
                                v-close-popover
                              >
                                <span
                                  v-if="
                                    !$v.modeloVuelidate.ejes_modelo.$each[
                                      indexEjeModelo
                                    ].disciplinas_eje.$each[indexDisciplinaEje]
                                      .driver_experiencia.required
                                  "
                                  >¡No te olvides de éste campo!</span
                                >
                              </span>
                            </template>
                          </v-popover>
                        </template>
                      </v-radio-group>
                    </v-col>
                  </v-row>
                </v-card>
              </template>
              <v-row>
                <v-col
                  :offset-md="1"
                  :offset-lg="1"
                  :offset-xl="3"
                  :xs="12"
                  :sm="12"
                  :md="10"
                  :lg="10"
                  :xl="6"
                >
                  <div class="btnAgregar">
                    <v-btn
                      @click="addNewTempDisciplinaEje(indexEjeModelo)"
                      small
                      class="black--text"
                      dark
                      tile
                      color="white"
                    >
                      <v-avatar size="20" tile>
                        <v-img
                          :contain="true"
                          :aspect-ratio="1"
                          position="center"
                          src="@/assets/img/icoSimpleAgregar.svg"
                          class="black--text"
                        ></v-img> </v-avatar
                      >Añadir nueva disciplina
                    </v-btn>
                  </div>
                </v-col>
              </v-row>
            </v-sheet>
          </template>
        </div>
      </v-tab-item>
    </v-tabs>
    <template>
      <v-dialog v-model="dialogDelete" persistent max-width="600px">
        <v-card>
          <v-card-title>
            <div class="titModal">
              <strong>¿Seguro que deseas eliminar esta disciplina?</strong>
            </div>
          </v-card-title>
          <v-card-text></v-card-text>
          <v-card-actions>
            <v-row justify="center" style="margin-right:0px">
              <v-btn
                class="ma-2"
                dark
                tile
                depressed
                color="secondary"
                @click="dialogDelete = false"
                >No, cancelar</v-btn
              >
              <v-btn
                class="ma-2"
                depressed
                dark
                tile
                color="primary"
                @click="deleteTempDisciplinaEje"
                >Si, continuar</v-btn
              >
            </v-row>
          </v-card-actions>
        </v-card>
      </v-dialog>
      <v-dialog v-model="dialogNewDisciplina" persistent max-width="600px">
        <v-card style="border:1px solid #fff;">
          <v-card-title>
            <div class="titModal">
              <strong>Nueva Disciplina</strong>
            </div>
          </v-card-title>
          <template v-if="tempEditingDisciplina">
            <Disciplina
              :finishEditingDisciplina="finishEditingDisciplina"
              :data="isTempEditingDisciplina"
              :metadata="metadata"
            />
          </template>
        </v-card>
      </v-dialog>
    </template>
  </div>
</template>
<style scoped>
.v-tab {
  text-transform: none;
}
</style>
<style>
.validation-total .v-input__control .v-input__slot .v-text-field__slot {
  border: #ffcc00 solid;
  height: 32px;
}
.validation-total.v-text-field > .v-input__control > .v-input__slot:before {
  border: none;
}
#display .v-speed-dial {
  position: absolute;
}
#display .v-btn--floating {
  position: relative;
}
.v-list-item--disabled {
  display: none;
}
</style>
<script>
import axios from "axios";
import store from "@/store";
import Disciplina from "@/views/secure/modelo-franquicia/franquicias/modelos/components/Disciplina.vue";
import { mapState } from "vuex";
import router from "@/router";
import { required, between } from "vuelidate/lib/validators";
const serviceLocalStorage = store.state.serviceLocalStorage;
const serviceCommons = store.state.serviceCommons;
const user = serviceLocalStorage.userToken();
export default {
  name: "Component-GestionDisciplinasEjesModeloFranquicia",
  props: ["data"],
  components: {
    Disciplina
  },
  data() {
    return {
      dialogDelete: false,
      dialogNewDisciplina: false,
      tempEditingDisciplina: null,
      isTempEditingDisciplina: null,
      tempDeletingDisciplinaEje: null,
      tempIndexEjeModeloDeleting: null,
      tempIndexDeletingDisciplinaEje: null
    };
  },
  validations: {
    modeloVuelidate: {
      ejes_modelo: {
        $each: {
          disciplinas_eje: {
            required,
            $each: {
              id_disciplina: {
                required
              },
              id_tipo_medicion: {
                required
              },
              id_frecuencia_medicion: {
                required
              },
              id_ejecuta: {
                required
              },
              driver_experiencia: {
                required
              }
            }
          }
        }
      }
    }
  },
  computed: {
    modelo() {
      if (!this.data.modelo) {
        return {};
      }
      return this.data.modelo;
    },
    metadata() {
      if (!this.data.metadata) {
        return {};
      }
      return this.data.metadata;
    },
    avalibleDisciplina() {
      let ejesFiltered = [];
      if (this.metadata.disciplinas) {
        ejesFiltered = JSON.parse(JSON.stringify(this.metadata.disciplinas));
      }
      return ejesFiltered.filter(itemDisiciplia => {
        this.modelo.ejes_modelo.forEach(itemEjeModelo => {
          itemEjeModelo.disciplinas_eje.filter(itemDisciplinaEje => {
            if (
              itemDisciplinaEje.id_disciplina &&
              itemDisciplinaEje.id_disciplina === itemDisiciplia.id_disciplina
            ) {
              itemDisiciplia.disabled = true;
            }
          });
        });
        return itemDisiciplia;
      });
    },
    modeloVuelidate() {
      const modeloVuelidate = JSON.parse(JSON.stringify(this.modelo));
      if (modeloVuelidate.ejes_modelo) {
        modeloVuelidate.ejes_modelo = modeloVuelidate.ejes_modelo.filter(
          itemEjeModelo => {
            if (itemEjeModelo.disciplinas_eje) {
              itemEjeModelo.disciplinas_eje = itemEjeModelo.disciplinas_eje.filter(
                itemDisciplinaEje => {
                  return !itemDisciplinaEje.deleted;
                }
              );
            }
            return !itemEjeModelo.deleted;
          }
        );
      }
      return modeloVuelidate;
    },
    disableEditEjesModelo() {
      return this.modelo && this.modelo.id_modelo;
    },
    serviceCommons() {
      return serviceCommons;
    }
  },
  methods: {
    ejesActiveModelo() {
      if (this.modelo.ejes_modelo) {
        return this.modelo.ejes_modelo.filter(itemEjeModelo => {
          return !itemEjeModelo.deleted;
        });
      }
    },
    disciplinasActiveEje(indexEjeModelo) {
      let ejeModelo = this.modelo.ejes_modelo[indexEjeModelo];
      let disciplinasEje = ejeModelo.disciplinas_eje;
      if (!disciplinasEje) {
        disciplinasEje = [];
      }
      let indexDisciplina = 0;
      return disciplinasEje.filter(itemDisciplinaEje => {
        if (!itemDisciplinaEje.deleted) {
          indexDisciplina++;
          itemDisciplinaEje.no = indexDisciplina;
          if (
            ejeModelo.search_disciplina &&
            ejeModelo.search_disciplina !== ""
          ) {
            let disciplina = this.getDisciplinaFromMetadata(
              itemDisciplinaEje.id_disciplina
            );
            return disciplina.descripcion
              .toLowerCase()
              .includes(ejeModelo.search_disciplina.toLowerCase());
          } else {
            return itemDisciplinaEje;
          }
        }
      });
    },
    getEjeModeloByIndex(indexEjeModelo) {
      if (this.modelo.ejes_modelo) {
        let eje_modelo_filtered = this.modelo.ejes_modelo.filter(
          (itemEjeModelo, indexItemEjeModelo) =>
            indexItemEjeModelo === indexEjeModelo
        )[0];
        return eje_modelo_filtered;
      }
    },
    getIndexEjeModeloById(idEjeModelo) {
      if (this.modelo.ejes_modelo) {
        let indexEjeModelo = null;
        this.modelo.ejes_modelo.forEach((itemEjeModelo, indexItemEjeModelo) => {
          if (itemEjeModelo.id_eje_modelo === idEjeModelo) {
            indexEjeModelo = indexItemEjeModelo;
          }
        });
        return indexEjeModelo;
      }
    },
    getDisciplinaFromMetadata(id_disciplina) {
      if (this.metadata.disciplinas) {
        let disciplina_filtered = this.metadata.disciplinas.filter(
          itemDisciplinas => itemDisciplinas.id_disciplina === id_disciplina
        )[0];
        if (disciplina_filtered) {
          return disciplina_filtered;
        }
        return {};
      }
      return {};
    },
    getEjeFromMetadata(id_eje) {
      if (this.metadata.ejes) {
        let eje_filtered = this.metadata.ejes.filter(
          itemEje => itemEje.id_eje === id_eje
        )[0];
        if (eje_filtered) {
          return eje_filtered;
        }
        return {};
      }
      return {};
    },
    addNewTempDisciplinaEje(indexEje) {
      const eje = this.getEjeModeloByIndex(indexEje);
      const tempNewDisciplinaEje = {
        id_eje_modelo: eje.id_eje_modelo,
        ponderacion: 0,
        inserted: true,
        indexOriginal:
          this.modelo.ejes_modelo[indexEje].disciplinas_eje.length + 1
      };
      this.modelo.ejes_modelo[indexEje].disciplinas_eje.push(
        tempNewDisciplinaEje
      );
    },
    deleteTempDisciplinaEje() {
      if (this.tempDeletingDisciplinaEje.id_disciplina_eje) {
        this.tempDeletingDisciplinaEje.deleted = true;
        this.refreshEjesModelo();
      } else {
        this.deleteDisciplinaEjeByIndex();
      }
      this.tempIndexEjeModeloDeleting = null;
      this.tempIndexDeletingDisciplinaEje = null;
      this.tempDeletingDisciplinaEje = null;
      this.dialogDelete = false;
    },
    deleteDisciplinaEjeByIndex() {
      this.modelo.ejes_modelo[
        this.tempIndexEjeModeloDeleting
      ].disciplinas_eje = this.modelo.ejes_modelo[
        this.tempIndexEjeModeloDeleting
      ].disciplinas_eje.filter(
        (itemDisciplinaEje, indexItemDisciplinaEje) =>
          itemDisciplinaEje.indexOriginal !==
          this.tempDeletingDisciplinaEje.indexOriginal
      );
    },
    editTempDisciplina(item) {
      this.tempEditingDisciplina = true;
      this.dialogNewDisciplina = true;
      this.isTempEditingDisciplina = JSON.parse(JSON.stringify(item));
    },
    refreshEjesModelo() {
      this.modelo.ejes_modelo = this.modelo.ejes_modelo.filter(itemEje => {
        return true;
      });
    },
    finishEditingDisciplina() {
      this.isTempEditingDisciplina = null;
      this.tempEditingDisciplina = false;
      this.dialogNewDisciplina = false;
    }
  },
  created() {}
};
</script>
